// msiarun.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <msi.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	DWORD dwResult = 0, cbSize = MAX_PATH;
	INSTALLSTATE is;
	PMSIHANDLE hProduct;
	TCHAR szBuff[MAX_PATH], szCurrDir[MAX_PATH], szFilePath[MAX_PATH], szProductCode[80];
	UINT uResult = 0;
	
	memset(szBuff, 0, sizeof(TCHAR) * MAX_PATH);
	memset(szCurrDir, 0, sizeof(TCHAR) * MAX_PATH);
	memset(szFilePath, 0, sizeof(TCHAR) * MAX_PATH);
	memset(szProductCode, 0, sizeof(TCHAR) * 80);

	// get the file from autorun.inf using a full path
	GetCurrentDirectory(cbSize, szCurrDir);
	strncpy(szFilePath, szCurrDir, MAX_PATH);
	strcat(szFilePath, TEXT("\\autorun.inf"));

	dwResult = GetPrivateProfileString(
		TEXT("autorun"),
		TEXT("msifile"),
		TEXT("setup.msi"),
		szBuff,
		MAX_PATH,
		szFilePath);
	
	// just exit on errors
	if (dwResult <= 0) return 1;

	// open the MSI package to get ProductCode
	strncpy(szFilePath, szCurrDir, MAX_PATH);
	strcat(szFilePath, TEXT("\\"));
	strcat(szFilePath, szBuff);

	uResult = MsiOpenPackage(
		szFilePath,
		&hProduct);

	if (uResult != ERROR_SUCCESS) return 1;

	// get ProductCode
	uResult = MsiGetProductProperty(
		hProduct,
		TEXT("ProductCode"),
		szProductCode,
		&cbSize);

	MsiCloseHandle(hProduct);
	if (uResult != ERROR_SUCCESS)
		return 1;

	// determine if the product is installed
	is = MsiQueryProductState(szProductCode);
	if (is == INSTALLSTATE_DEFAULT || is == INSTALLSTATE_ADVERTISED)
		return 0;
	else if (is != INSTALLSTATE_UNKNOWN && is != INSTALLSTATE_ABSENT)
		return 1;

	// now attempt installation of the msi package - don't worry about errors since
	// MSI will display the correct error message to the user.
	MsiSetInternalUI(INSTALLUILEVEL_FULL, NULL);
	uResult = MsiInstallProduct(szFilePath, NULL); // no parameters (properties)

	return uResult; // return code from MSI
}



